=== debian/changelog ===
modules (4.1.0-1) unstable; urgency=medium

  * New upstream release
  * Fix manual files location to /usr/share/man
  * Standards-Version: 4.1.3
  * Add 'less' as build dependency

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 20 Jan 2018 22:10:21 +0000

modules (4.0.0-2) unstable; urgency=medium

  * Fix symlink for bash completion. Closes: #879613
  * Fix paths.patch for sh that broke sudo , su use. Closes: #883169

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 05 Dec 2017 12:37:11 +0000
