## modules 4.1.1

=== Makefile ===
--- 
+++ 
@@ -20,21 +20,25 @@
 endif
 include Makefile.inc
 
-all: initdir pkgdoc modulecmd.tcl ChangeLog README \
+all: initdir modulecmd.tcl ChangeLog README \
 	contrib/scripts/add.modules contrib/scripts/modulecmd
 ifeq ($(compatversion),y)
 all: $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
 else
 endif
+# skip doc build if no sphinx-build
+ifeq ($(builddoc),y)
+all: pkgdoc
+endif
 
 initdir: version.inc
-	make -C init all
+	$(MAKE) -C init all
 
 pkgdoc: version.inc
-	make -C doc man txt
+	$(MAKE) -C doc man txt
 
 doc: version.inc
-	make -C doc all
+	$(MAKE) -C doc all
 
 # build version.inc shared definitions from git repository info
 ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
@@ -60,7 +64,7 @@
 else
 MODULES_RELEASE_SUFFIX := $(subst $(MODULES_RELEASE_BASE)-,,$(MODULES_RELEASE))
 endif
-MODULES_LAST_RPM_VERSREL := $(shell grep -Pzo -m 1 '%changelog\n+\*.* - \K.*\n' \
+MODULES_LAST_RPM_VERSREL := $(shell $(GREP) -Pzo -m 1 '%changelog\n+\*.* - \K.*\n' \
 	contrib/rpm/environment-modules.spec.in)
 
 MODULES_LAST_RPM_RELEASE := $(subst $(MODULES_RELEASE_BASE)-,,$(MODULES_LAST_RPM_VERSREL))
@@ -164,7 +168,7 @@
 
 # compatibility version-related rules
 $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog:
-	make -C $(COMPAT_DIR) $(@F)
+	$(MAKE) -C $(COMPAT_DIR) $(@F)
 
 # example configs for test rules
 testsuite/example/.modulespath: testsuite/example/.modulespath.in
@@ -174,23 +178,23 @@
 	$(translate-in-script)
 
 install-testsiteconfig: testsuite/example/siteconfig.tcl
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(etcdir)/
 
 install-testmodulerc: testsuite/example/modulerc
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(initdir)/
 
 install-testetcrc: testsuite/etc/empty
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(prefix)/etc/rc
 
 install-testmodspath: testsuite/example/.modulespath
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(initdir)/
 
 install-testmodspath-empty: testsuite/example/.modulespath-empty
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(initdir)/.modulespath
 
 uninstall-testconfig:
@@ -198,7 +202,7 @@
 	rm -f $(DESTDIR)$(etcdir)/siteconfig.tcl
 	rm -f $(DESTDIR)$(initdir)/modulerc
 	rm -f $(DESTDIR)$(initdir)/.modulespath
-	make -C init uninstall-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init uninstall-testconfig DESTDIR=$(DESTDIR)
 
 ifeq ($(compatversion),y)
 install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
@@ -233,8 +237,13 @@
 	cp $(COMPAT_DIR)/NEWS $(DESTDIR)$(docdir)/NEWS-compat
 endif
 endif
-	make -C init install DESTDIR=$(DESTDIR)
-	make -C doc install DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install DESTDIR=$(DESTDIR)
+ifeq ($(builddoc),y)
+	$(MAKE) -C doc install DESTDIR=$(DESTDIR)
+else
+	@echo
+	@echo "WARNING: Documentation not built nor installed"
+endif
 	@echo
 	@echo "NOTICE: Modules installation is complete."
 	@echo "        Please read the 'Configuration' section in INSTALL.txt to learn"
@@ -255,13 +264,18 @@
 ifeq ($(compatversion),y)
 	rm -f $(addprefix $(DESTDIR)$(docdir)/,ChangeLog-compat NEWS-compat)
 endif
-endif
-	make -C init uninstall DESTDIR=$(DESTDIR)
-	make -C doc uninstall DESTDIR=$(DESTDIR)
+ifneq ($(builddoc),y)
+	rmdir $(DESTDIR)$(docdir)
+endif
+endif
+	$(MAKE) -C init uninstall DESTDIR=$(DESTDIR)
+ifeq ($(builddoc),y)
+	$(MAKE) -C doc uninstall DESTDIR=$(DESTDIR)
+endif
 	rmdir $(DESTDIR)$(libexecdir)
 	rmdir $(DESTDIR)$(bindir)
 	rmdir $(DESTDIR)$(datarootdir)
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(prefix)
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(prefix) || true
 
 # include pre-generated documents not to require documentation build
 # tools when installing from dist tarball
@@ -276,7 +290,7 @@
 		doc/build/module.1.in doc/build/modulefile.4 \
 		contrib/rpm/environment-modules.spec
 ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
-	make -C $(COMPAT_DIR) distdir
+	$(MAKE) -C $(COMPAT_DIR) distdir
 	mv $(COMPAT_DIR)/modules-* compatdist
 	tar -cf compatdist.tar --transform 's,^compatdist,$(DIST_PREFIX)/compat,' compatdist
 	tar --concatenate -f $(DIST_PREFIX).tar compatdist.tar
@@ -320,14 +334,16 @@
 	rm -f testsuite/example/.modulespath testsuite/example/modulerc
 	rm -f modules-*.tar modules-*.tar.gz modules-*.tar.bz2
 	rm -f modules-*.srpm
-	make -C init clean
-	make -C doc clean
+	$(MAKE) -C init clean
+ifeq ($(builddoc),y)
+	$(MAKE) -C doc clean
+endif
 ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
 	rm -f version.inc
 	rm -f contrib/rpm/environment-modules.spec
 endif
 ifneq ($(wildcard $(COMPAT_DIR)/Makefile),)
-	make -C compat clean
+	$(MAKE) -C compat clean
 endif
 
 distclean: clean
@@ -336,12 +352,14 @@
 	rm -rf $(NAGELFAR_RELEASE)
 ifeq ($(wildcard .git) $(wildcard $(COMPAT_DIR)),.git $(COMPAT_DIR))
 	rm -rf $(COMPAT_DIR)
+ifeq ($(gitworktree),y)
 	git worktree prune
+endif
 endif
 
 ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
 test: modulecmd.tcl $(COMPAT_DIR)/modulecmd
-	make -C $(COMPAT_DIR) test
+	$(MAKE) -C $(COMPAT_DIR) test
 else
 test: modulecmd.tcl
 endif
@@ -350,13 +368,3 @@
 	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
 	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool modules
 
-testinstall:
-	OBJDIR=`pwd -P`; export OBJDIR; \
-	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
-	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool install
-
-
-# install code coverage tool
-$(NAGELFAR):
-	wget http://downloads.sourceforge.net/nagelfar/$(NAGELFAR_RELEASE).tar.gz
-	tar xzf $(NAGELFAR_RELEASE).tar.gz
