=== doc/Makefile ===
--- 
+++ 
@@ -16,6 +16,11 @@
 
 # source version definitions shared across the Makefiles of this project
 include ../version.inc
+
+# quit if no sphinx-build found at configure time
+ifneq ($(builddoc),y)
+  $(error No 'sphinx-build' command defined, cannot build documentation)
+endif
 
 man: $(BUILD_DIR)/module.1 $(BUILD_DIR)/modulefile.4
 ifeq ($(compatversion),y)
@@ -74,7 +79,7 @@
 
 # compatibility version-related rules
 $(COMPAT_MAN_DIR)/module.1 $(COMPAT_MAN_DIR)/modulefile.4:
-	make -C $(COMPAT_MAN_DIR) $(@F)
+	$(MAKE) -C $(COMPAT_MAN_DIR) $(@F)
 
 install: man txt
 	mkdir -p $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man4
