=== init/Makefile ===
--- 
+++ 
@@ -29,10 +29,10 @@
 endif
 
 # generate 'module use' commands to put in modulerc from modulepath
-modulerc := $(addprefix \nmodule use --append {,$(subst :,} {,$(modulepath)}))
+modulerc := $(addprefix \\\nmodule use --append {,$(subst :,} ,$(modulepath)}))
 # generate 'module load' commands to put in modulerc from loadedmodules
 ifneq ($(loadedmodules),)
-  modulerc := $(modulerc)$(addprefix \nmodule load ,\
+  modulerc := $(modulerc)$(addprefix \\\nmodule load ,\
     $(subst :, ,$(loadedmodules)))
 endif
 
@@ -66,6 +66,13 @@
 else
   compatversionre := /@compatversion@/d
   notcompatversionre := s|@notcompatversion@||g
+endif
+ifeq ($(usemanpath),y)
+  usemanpathre := s|@usemanpath@||g
+  notusemanpathre := /@notusemanpath@/d
+else
+  usemanpathre := /@usemanpath@/d
+  notusemanpathre := s|@notusemanpath@||g
 endif
 
 # comment entries if feature not enabled
@@ -106,13 +113,17 @@
 	-e '$(setbinpathre)' \
 	-e '$(compatversionre)' \
 	-e '$(notcompatversionre)' \
-	-e 's|@modulerc@|$(modulerc)|g' \
+	-e '$(usemanpathre)' \
+	-e '$(notusemanpathre)' \
+	-e $$'s|@modulerc@|$(modulerc)|g' \
 	-e 's|@modulepath@|$(modulepath)|g' \
 	-e '$(setquarvarsre)' $(quarvarsre) \
 	-e '$(notsetquarvarsre)' \
 	-e 's|@SHELLNAME@|$@|g' \
 	-e 's|@VERSIONING@|$(setversioning)|g' \
 	-e 's|@VERSION@|$(VERSION)|g' \
+	-e 's|@PS@|$(PS)|g' \
+	-e 's|@BASENAME@|$(BASENAME)|g' \
 	-e 's|@TCLSH@|$(TCLSH)|g' $< > $@
 endef
 
@@ -121,6 +132,13 @@
 
 %: %.in
 	$(translate-in-script)
+
+# workaround '\\\n' issue on Linux with Make 3.81
+modulerc: modulerc.in
+	$(translate-in-script)
+	mv $@ ${@}.tmp
+	sed -e 's|\\$$||' ${@}.tmp > $@
+	rm -f ${@}.tmp
 
 # tcsh is derivated from csh init script
 tcsh: csh.in
@@ -152,9 +170,9 @@
 uninstall-testconfig:
 	rmdir $(DESTDIR)$(prefix)/test/modulefiles $(DESTDIR)$(prefix)/test/etc $(DESTDIR)$(prefix)/test
 	rm -f $(addprefix $(DESTDIR)$(modulefilesdir)/,$(EXAMPLE_TESTCONFIG_MODFILES))
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(modulefilesdir)
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(etcdir)
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(initdir)
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(modulefilesdir) || true
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(etcdir) || true
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(initdir) || true
 
 install: all
 	mkdir -p $(DESTDIR)$(initdir)
@@ -169,7 +187,8 @@
 else
 	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
 endif
-	cp -P --remove-destination $(ALL_CONFIG) $(DESTDIR)$(initdir)/
+	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_CONFIG))
+	cp -R -P $(ALL_CONFIG) $(DESTDIR)$(initdir)/
 ifeq ($(examplemodulefiles),y)
 	cp $(addprefix $(EXAMPLE_MODFILES_SRCDIR)/,$(EXAMPLE_MODFILES)) $(DESTDIR)$(modulefilesdir)/
 endif
@@ -186,16 +205,16 @@
 endif
 	rm -f $(DESTDIR)$(initdir)/zsh-functions/_module
 	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_CONFIG))
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(modulefilesdir)
-	@if [ -d $(DESTDIR)$(modulefilesdir) ]; then echo -e "\nWARNING: $(DESTDIR)$(modulefilesdir) is not empty so skip removal\n" >&2; fi
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(modulefilesdir) || true
+	@if [ -d $(DESTDIR)$(modulefilesdir) ]; then echo; echo "WARNING: $(DESTDIR)$(modulefilesdir) is not empty so skip removal" >&2; echo; fi
 	rmdir $(DESTDIR)$(initdir)/ksh-functions
 	rmdir $(DESTDIR)$(initdir)/zsh-functions
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(initdir)
-	@if [ -d $(DESTDIR)$(initdir) ]; then echo -e "\nWARNING: $(DESTDIR)$(initdir) is not empty so skip removal\n" >&2; fi
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(initdir) || true
+	@if [ -d $(DESTDIR)$(initdir) ]; then echo; echo "WARNING: $(DESTDIR)$(initdir) is not empty so skip removal" >&2; echo; fi
 ifeq ($(versioning),y)
 	rm -f $(DESTDIR)$(versdir)/$(VERSION)
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(versdir)
-	@if [ -d $(DESTDIR)$(versdir) ]; then echo -e "\nWARNING: $(DESTDIR)$(versdir) is not empty so skip removal\n" >&2; fi
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(versdir) || true
+	@if [ -d $(DESTDIR)$(versdir) ]; then echo; echo "WARNING: $(DESTDIR)$(versdir) is not empty so skip removal" >&2; echo; fi
 endif
 
 clean:
