=== debian/changelog ===
modules (4.1.1-1) unstable; urgency=medium

  * New upstream release
  * Set VCS to point to salsa.debian.org
  * Ack. and close old bug on bash completion: Closes: #865118
  * Delete obsolete patches:
    - compiler_fixes.patch
    - debian/patches/fix_paths.patch
    - debian/patches/format.patch
  * Update  testsuite-fix.patch
  * Set mandir, etcdir in ./rules to configure site.exp correctly
  * set initdir. Closes: #890781
  * Add procps as a build-dep / runtime dependency

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Feb 2018 16:47:47 +0000
