=== debian/control ===
--- 
+++ 
@@ -4,15 +4,19 @@
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Standards-Version: 4.1.3
 Homepage: http://modules.sourceforge.net/
+Vcs-Browser: https://salsa.debian.org:/mckinstry/modules.git
+Vcs-Git: https://salsa.debian.org:/mckinstry/modules.git
 Build-Depends: tcl8.6-dev | tcl-dev, 
   debhelper (>= 10), 
   dejagnu, 
   tclx8.4-dev,
-  less
+  less,
+  procps
 
 Package: environment-modules
 Architecture: any
-Depends: debhelper (>= 10), tcl8.6 | tcl, ${misc:Depends}, ${shlibs:Depends}
+Depends: tcl8.6 | tcl, ${misc:Depends}, ${shlibs:Depends},
+ less, procps
 Conflicts: lmod
 Description: Modular system for handling environment variables
  The Modules package provides for the dynamic modification of a user's
