## modules 4.1.2

=== debian/changelog ===
modules (4.1.2-2) unstable; urgency=medium

  * Fix from Christophe Garion for zsh handling. Closes: #897686
  * Standards-Version: 4.1.4; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 May 2018 10:25:30 +0100

modules (4.1.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 04 Apr 2018 07:15:54 +0100
