## modules 4.1.3

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,15 @@
-.PHONY: doc pkgdoc initdir install install-testsiteconfig install-testmodulerc \
-	install-testetcrc install-testmodspath install-testmodspath-empty \
-	uninstall-testconfig uninstall dist dist-tar dist-gzip dist-bzip2 srpm \
-	clean distclean test testinstall instrument testcoverage
+.PHONY: doc pkgdoc initdir install install-testsiteconfig \
+	install-testsiteconfig-1 install-testmodulerc install-testetcrc \
+	install-testmodspath install-testmodspath-empty uninstall-testconfig \
+	uninstall dist dist-tar dist-gzip dist-bzip2 srpm clean distclean test \
+	testinstall instrument testcoverage
 
 # definitions for code coverage
+NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
+NAGELFAR_DLSRC2 := https://ftp.openbsd.org/pub/OpenBSD/distfiles/
 NAGELFAR_RELEASE := nagelfar125
+NAGELFAR_DIST := $(NAGELFAR_RELEASE).tar.gz
+NAGELFAR_DISTSUM := 707e3c305437dce1f14103f0bd058fc9
 NAGELFAR := $(NAGELFAR_RELEASE)/nagelfar.tcl
 COVERAGE_SRCFILE := modulecmd.tcl
 COVERAGE_IFILE := $(COVERAGE_SRCFILE:.tcl=.tcl_i)
@@ -23,7 +28,7 @@
 all: initdir modulecmd.tcl ChangeLog README \
 	contrib/scripts/add.modules contrib/scripts/modulecmd
 ifeq ($(compatversion),y)
-all: $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
+all: $(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog
 else
 endif
 # skip doc build if no sphinx-build
@@ -167,7 +172,7 @@
 	$(translate-in-script)
 
 # compatibility version-related rules
-$(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog:
+$(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog:
 	$(MAKE) -C $(COMPAT_DIR) $(@F)
 
 # example configs for test rules
@@ -180,6 +185,10 @@
 install-testsiteconfig: testsuite/example/siteconfig.tcl
 	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(etcdir)/
+
+install-testsiteconfig-1: testsuite/example/siteconfig.tcl-1
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
+	cp $^ $(DESTDIR)$(etcdir)/siteconfig.tcl
 
 install-testmodulerc: testsuite/example/modulerc
 	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
@@ -206,7 +215,7 @@
 
 ifeq ($(compatversion),y)
 install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
-	contrib/scripts/modulecmd $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
+	contrib/scripts/modulecmd $(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog
 else
 install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
 	contrib/scripts/modulecmd
@@ -216,8 +225,8 @@
 	cp modulecmd.tcl $(DESTDIR)$(libexecdir)/
 	chmod +x $(DESTDIR)$(libexecdir)/modulecmd.tcl
 ifeq ($(compatversion),y)
-	cp $(COMPAT_DIR)/modulecmd $(DESTDIR)$(libexecdir)/modulecmd-compat
-	chmod +x $(DESTDIR)$(libexecdir)/modulecmd-compat
+	cp $(COMPAT_DIR)/modulecmd$(EXEEXT) $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
+	chmod +x $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
 endif
 	cp contrib/envml $(DESTDIR)$(bindir)/
 	chmod +x $(DESTDIR)$(bindir)/envml
@@ -253,7 +262,7 @@
 uninstall:
 	rm -f $(DESTDIR)$(libexecdir)/modulecmd.tcl
 ifeq ($(compatversion),y)
-	rm -f $(DESTDIR)$(libexecdir)/modulecmd-compat
+	rm -f $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
 endif
 	rm -f $(DESTDIR)$(bindir)/envml
 	rm -f $(DESTDIR)$(bindir)/add.modules
@@ -350,21 +359,3 @@
 	rm -f Makefile.inc
 	rm -f site.exp
 	rm -rf $(NAGELFAR_RELEASE)
-ifeq ($(wildcard .git) $(wildcard $(COMPAT_DIR)),.git $(COMPAT_DIR))
-	rm -rf $(COMPAT_DIR)
-ifeq ($(gitworktree),y)
-	git worktree prune
-endif
-endif
-
-ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
-test: modulecmd.tcl $(COMPAT_DIR)/modulecmd
-	$(MAKE) -C $(COMPAT_DIR) test
-else
-test: modulecmd.tcl
-endif
-	TCLSH=$(TCLSH); export TCLSH; \
-	OBJDIR=`pwd -P`; export OBJDIR; \
-	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
-	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool modules
-
