=== debian/changelog ===
modules (4.1.3-1) unstable; urgency=medium

  * New upstream release
  * zsh-modulecmd.patch merged upstream`

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Jul 2018 20:17:12 +0100
