## modules 4.2.0

=== debian/changelog ===
modules (4.2.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.2.1
  * Remove hard-coded xz compression for deb tarball

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 24 Oct 2018 11:31:00 +0100

modules (4.1.4-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.2.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Aug 2018 07:49:11 +0100
