## modules 4.2.1

=== debian/changelog ===
modules (4.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 13 Nov 2018 06:57:03 +0000
